Name: registry
Version: 0.1.6
Release: 1
Source:    http://registry.sf.net/%{name}-%{version}.tar.gz
Group:     System Environment/Libraries
Copyright: LGPL
Vendor: Avi Alkalay <avi@unix.sh>
Packager: Avi Alkalay <avi@unix.sh>
URL: http://registry.sf.net
BuildRoot:   %{_tmppath}/%{name}-%{version}-build
BuildRequires: /usr/bin/xsltproc
Summary: A registry to store general key-value pairs instead of text configuration files

%description
The Linux Registry is an alternative back-end for text configuration files.

Instead of each program to have its own text configuration files, the Registry tries to provide a universal, fast, consistent, robust, thread-safe and transactional infrastructure to store configuration parameters through a key-value pair mechanism.

This way any software can read/save his configuration using a consistent API. Also, applications can be aware of other applications configurations, leveraging easy application integration.


%package devel
Summary: Include files and API documentation for the Linux Registry
Group: Development/System
Requires: registry = %{version}-%{release}

%description devel
The Linux Registry is an alternative back-end for text configuration files.

Instead of each program to have its own text configuration files, the Registry tries to provide a universal, fast, consistent, robust, thread-safe and transactional infrastructure to store configuration parameters through a key-value pair mechanism.

This way any software can read/save his configuration using a consistent API. Also, applications can be aware of other applications configurations, leveraging easy application integration.

This package contains the include files and API manual pages to use the Registry API in C.

%prep
%setup -n registry
%build
# Setup for parallel builds
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
	numprocs=1
fi

make all

%install
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/usr/include
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/registry
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/registry-devel
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man1
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man3
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man5
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man7

make DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT/*
rm -rf $RPM_BUILD_DIR/registry




%post
# Create basic key structure for apps
rg set -t dir system.sw


%files
%defattr(-,root,root,0755)
/lib/*
/bin/*
/usr/share/doc/registry
/usr/share/man/man1/*
/usr/share/man/man7/*
/usr/share/man/man5/*


%files devel
/usr/include/*
/usr/share/doc/registry-devel
/usr/share/man/man3/*

%changelog


* Wed Mar 31 2004 Avi Alkalay <avi@unix.sh> 0.1.6
- One more bug related to strblen in registryFileUnserialize(), causing wrong data size calculation

* Wed Mar 31 2004 Avi Alkalay <avi@unix.sh> 0.1.5
- Fixed in registryGetKey: Keys allways needed sync
- Fixed bug releated to NEEDSYNC: ~RG_KEY_FLAG_NEEDSYNC needed a special cast to use the right number of bits
- Improved HOWTO documentation and manual. Link to ReiserFS.
- Started writting of the key.3 manual

* Mon Mar 29 2004 Avi Alkalay <avi@unix.sh> 0.1.4
- Written manual pages rg(1), registry(7), registry(5) and registry(3) using DocBook
- Ported the OpenOffice.org specification to DocBook, using the modularized man pages
- RPMs include manpages
- RPMs have prerequesites now
- Fixed bug regarding \0 in end of key names on recursive stats
- More robust build system, catching warnings
- New method: registryGetRootKeys(KeySet *returned)
- Fixed some bugs related to usage of strblen()
- Introduction of the RG_O_* method options
- Removed bug related to permission when stat()ing keys
- Removed bugs in some KeySet methods
- Much improved 'rg ls' command, specially in recursive mode
- New key flag, NEEDSYNC, to indicate the change status of a key
- New method, registrySetKeys, to commit all modified keys on a KeySet

* Tue Mar 16 2004 Avi Alkalay <avi@unix.sh> 0.1.2
- The Linux Registry API is 100% usable
- The rg command is very usable
- Full support to UTF-8. Everything stored in the registry is UTF-8, regardeless of user's LANG. Conversions are on the fly.
- Fixed bug on keySetName(), regarding wrong keyNameSize
- Introduction of registryRemoveKey()
- rg subcommands: ls, get, set, rm
- rg now supports set octal permissions from command line
- Key and Registry support for DIR type
- Documentation process (man pages) in the very begining
- Include files in a separate package

* Sat Mar 06 2004 Avi Alkalay <avi@unix.sh> 0.0.9
- Now no more IPC, Berkeley DB, threads, setuid, and other complexities
- Simple library that accesses files on disk
- rg has 'set' and partial 'ls' subcommands implemented
- API can already be used

* Sat Feb 15 2004 Avi Alkalay <avi@unix.sh> 0.0.2
- Based on IPC, Berkeley DB, Threads, and many other complexities
